<%@ page errorPage="/resources/jsp/errorpage.jsp" %>
<%@page import="java.util.HashMap"%>
<%@page import="java.io.InputStream" %>
<%@page import="java.io.IOException" %>
<%@page import="java.util.Properties" %>
<%@page import="java.util.Map"%>
<%@page import="java.util.Vector" %>
<%@page import="java.util.logging.Logger" %>
<%@page import="com.tarantella.tta.webservices.IConstantsGUI" %>
<%@page import="com.tarantella.tta.webservices.IConstantsSSO" %>
<%@page import="com.tarantella.tta.webservices.IFaultCodes" %>
<%@page import="com.tarantella.tta.webservices.ISchemaNames" %>
<%@page import="com.tarantella.tta.webservices.Item" %>
<%@page import="com.tarantella.tta.webservices.client.views.SessionBean" %>
<%@page import="com.tarantella.tta.webservices.client.views.DataRequest" %>
<%@ page import="com.tarantella.tta.webservices.TTAException" %>
<%@ page import="com.tarantella.tta.webservices.parser.ResponseParser" %>
<%@ page import="com.tarantella.tta.webservices.parser.IResponse" %>
<%@ page import="com.swiveltechnologies.proxy.PINsafeClient" %>

<%-- Session Management --%>
<%@ include file="/resources/jsp/utilities.jsp" %>
<%
   pageContext.setAttribute(PARAM_SESSION_AUTHENTICATE, "false", PageContext.REQUEST_SCOPE);
%>

<%@ include file="/resources/jsp/localeutils.jsp" %>
<%
   // initialise class variables
   setContext(request, response, pageContext);
%>

<%!
void debug(String id, String s) {
     //System.out.println("--<jsp." + id + "> " + s);
}
void debug(String s) { debug("ttaAuthentication", s); }
void debug(String msg, DataRequest[] dataRequests) {
    if (dataRequests != null) {
	debug(msg);
	for (DataRequest dr: dataRequests) debug("  dr.att=" + dr.getAttributeName());
    } else {
	debug(msg + " empty");
    }
}

DataRequest[] getInitialRequestsExt(PageContext pageContext, String req0, String val0, String req1, String val1, DataRequest[] existingRequests){
   debug("getInitialRequests", "req0=" + req0 + ", req1=" + req1);
   int requests = 3;
   LinkedList<DataRequest> additionalRequests = new LinkedList<DataRequest>();
   if (existingRequests != null){
        
        for( int j = 0; j < existingRequests.length; j++){
            DataRequest req = existingRequests[j];
            if(!req.getFeature(IConstantsGUI.TYPE,"").equalsIgnoreCase("none")){
                requests++;
                additionalRequests.add(req);
            }
        }
   }

   DataRequest[] dataRequests = new DataRequest[requests];
   if (val0 == null) val0 = "";
   if (val1 == null) val1 = "";
    
   dataRequests[0] = new DataRequest(req0);
   dataRequests[0].setFeature(IConstantsGUI.PROMPT, getWebtopString(pageContext, "I0_LoginUsername"));
   dataRequests[0].setFeature(IConstantsGUI.READONLY, false);
   dataRequests[0].setFeature(IConstantsGUI.TYPE, "text");
   dataRequests[0].setFeature(IConstantsGUI.MAXLENGTH, 100);
   dataRequests[0].setFeature(IConstantsGUI.SIZE, 15);
   dataRequests[0].setFeature(IConstantsGUI.VALUE, val0);

   dataRequests[1] = new DataRequest(req1);
   dataRequests[1].setFeature(IConstantsGUI.PROMPT, getWebtopString(pageContext, "I0_LoginPassword"));
   dataRequests[1].setFeature(IConstantsGUI.READONLY, false);
   dataRequests[1].setFeature(IConstantsGUI.ENCODED, true);
   dataRequests[1].setFeature(IConstantsGUI.TYPE, "password");
   dataRequests[1].setFeature(IConstantsGUI.MAXLENGTH, 100);
   dataRequests[1].setFeature(IConstantsGUI.SIZE, 15);
   dataRequests[1].setFeature(IConstantsGUI.VALUE, val1);

   dataRequests[2] = new DataRequest("Otc");
   dataRequests[2].setFeature(IConstantsGUI.PROMPT, "OTC");
   dataRequests[2].setFeature(IConstantsGUI.READONLY, false);
   dataRequests[2].setFeature(IConstantsGUI.ENCODED, true);
   dataRequests[2].setFeature(IConstantsGUI.TYPE, "password");
   dataRequests[2].setFeature(IConstantsGUI.MAXLENGTH, 100);
   dataRequests[2].setFeature(IConstantsGUI.SIZE, 15);
   dataRequests[2].setFeature(IConstantsGUI.VALUE, "");
    
    if(additionalRequests.size() != 0){
        for(int i = 0; i < additionalRequests.size(); i++){
            dataRequests[i+2] = additionalRequests.get(i);
        }
    }

   return dataRequests;
}

DataRequest[] getInitialRequests(PageContext pageContext, String req0, String val0, String req1, String val1)
{
    return getInitialRequestsExt(pageContext, req0, val0, req1, val1, null);
}

IResponse getChild(IResponse ir, String name) throws Exception
{
    Enumeration e = ir.getChildren();
    while (e.hasMoreElements()) {
        ir = (IResponse) e.nextElement();
        if (name.equals(ir.getElementName())) return ir;
    }
    throw new Exception("not found");
}

IResponse getPath(IResponse ir, String path) throws Exception
{
    for (String name: path.split("/")) ir = getChild(ir, name);
    return ir;
}

String _getAttr(IResponse ir, String path, String att)
{
    try { return getPath(ir,path).getAttribute(att)[0]; }
    catch (Exception x) {}
    return null;
}

String getAttr(IResponse ir, String path, String att)
{
    String r = _getAttr(ir,path,att);
    debug("getAttr", "path=" + path + ", att=" + att + ", r=" + r);
    return r;
}

%>

<%
   Logger logger = Logger.getLogger(this.getClass().getName());

   response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
   response.setHeader("Pragma","no-cache"); //HTTP 1.0
   response.setDateHeader ("Expires", 0); //prevents caching at the proxy server

   final String PASSWORD_REQUEST = "Password";
   final String USERNAME_REQUEST = "Username";
   final String OTC_REQUEST = "Otc";

   String username = (String) request.getParameter(PARAM_SESSION_USERNAME);
   String password =  (String) request.getParameter(PARAM_SESSION_PASSWORD);
   String clientid = (String) request.getParameter(PARAM_SESSION_CLIENTID);
   String locale = (String) request.getParameter(PARAM_SESSION_LOCALE);

   // Did the user attempt SSO ?
   boolean usingSSO = false;
   String oamReqId = (String)pageContext.getAttribute(IConstantsSSO.OAM_REQUEST_ID, PageContext.SESSION_SCOPE);
   if (oamReqId != null)
      usingSSO = true;

   if (clientid == null)
   {
     clientid = (String)pageContext.getAttribute(CLIENT_COOKIE, PageContext.SESSION_SCOPE);
   }

   Boolean buttonResponse = false;
   String buttonPrompt = null;
   String buttonLabels = null;
   String buttonOption = null;

   String prefLang = getPrefLang(pageContext);
   if (prefLang==null || prefLang.length()<2) prefLang = "en-us";

   debug("ttaAuthentication", "username=" + username + ", password=" + password);
         
   DataRequest[] dataRequests = (DataRequest[])pageContext.getAttribute(LOGIN_REQUESTS, PageContext.SESSION_SCOPE);
   SessionBean ttaSessionObject = getSGDSession(pageContext, SESSION_OBJ);
      
   if (ttaSessionObject != null)
   {
      String initialPage = (String) ttaSessionObject.getValue(ENTRY_URL);
      if (initialPage == null || initialPage.length() == 0)
      {
         response.sendRedirect(getContextPath(request) + "/resources/jsp/errorstopped.jsp");
         return;
      }

      /** Change the langSelected query Parameter to prefLang **/
      initialPage = changeURLQueryParameter(initialPage, "langSelected", prefLang);

      /* change the langSelected to the preferred language */
      pageContext.setAttribute("langSelected", prefLang, PageContext.SESSION_SCOPE);
      /* Update the ENTRY URL to reflect new lang */
      ttaSessionObject.addValue(ENTRY_URL, initialPage);
      
      boolean authenticated = true;
      String redirectURL = response.encodeRedirectURL(getBaseURL(request) + initialPage);
      
      if(isH5C(pageContext)){
        // For Android, we have to tell the H5C whether an app tab is visible
        // or not.  Bug 14785807.
        String newEntryURL = initialPage;
        if (newEntryURL.matches(".*?.*visible=.*")) {
            // Remove pre-existing visible parameter
            String[] urlParts = newEntryURL.split("\\?", 2);
            if (urlParts.length == 2) {
                newEntryURL = urlParts[0];
                String[] qsParts = urlParts[1].split("&");
                boolean paramAdded = false;
                for (int i=0; i<qsParts.length; i++) {
                    String p = qsParts[i];
                    if (!p.matches("visible=.*")) {
                        if (paramAdded) newEntryURL += "&";
                        else newEntryURL += "?";
                        newEntryURL += p;
                        paramAdded = true;
                    }
                }
            }
        }

        // Add a visible=true query string parameter.
        if (newEntryURL.contains("?")) {
            newEntryURL += "&";
        } else {
            newEntryURL += "?";
        }
        newEntryURL += "visible=true";
        ttaSessionObject.addValue(ENTRY_URL, newEntryURL);
      }
      
      
      // Get away from this page if the session is already authenticated.
      if (!ttaSessionObject.haveAuthentication())
      {
	 debug("===============");
         authenticated = false;
         // If there are no requests for data set, this must be the first call.  Set some and go to the login GUI.
         if (dataRequests == null && username == null && password == null)
         {
            dataRequests = getInitialRequests(pageContext, USERNAME_REQUEST, null, PASSWORD_REQUEST, null);
         }
         else
         {
            // Try to authenticate with what we have
            try
            {
	       debug("initial dataRequests:", dataRequests);

				String otc = "";
               // Check first for the simple username/password GUI
               if (dataRequests != null && (dataRequests.length == 2 || dataRequests.length == 3) &&
                  dataRequests[0].getAttributeName().equals(USERNAME_REQUEST) &&
                  dataRequests[1].getAttributeName().equals(PASSWORD_REQUEST))
               {
                  // Turn username and password into unicode
                  username = htmlUnescape(htmlUnescape(request.getParameter(USERNAME_REQUEST)));
                  password = htmlUnescape(htmlUnescape(request.getParameter(PASSWORD_REQUEST)));
				  if (dataRequests.length == 3 && dataRequests[2].getAttributeName().equals(OTC_REQUEST)) {
					String otc = htmlUnescape(htmlUnescape(request.getParameter(OTC_REQUEST)));
				  }
               }

	       debug("username=" + username);
	       debug("password=" + password);
		   debug("otc     =" + otc);

	       // ---

	       buttonPrompt = (String)pageContext.getAttribute(BUTTON_PROMPT, PageContext.SESSION_SCOPE);
	       buttonLabels = (String)pageContext.getAttribute(BUTTON_LABELS, PageContext.SESSION_SCOPE);

	       debug("buttonPrompt=" + buttonPrompt);
	       debug("buttonLabels=" + buttonLabels);

	       if (buttonPrompt != null) {
		   int n;
		   for (n=0; n<10; n++) {
		       if (request.getParameter("Button_" + n) != null) break;
		   }
		   debug("n=" + n);
		   if (n < 10) buttonOption = buttonLabels.split("@")[n];
		   debug("buttonOption=" + buttonOption);
	       }

	       // ---
               
               if (username != null && password != null)
               {
                  if (clientid == null)
                     clientid = "boo";
                  if (usingSSO)
                  {
                     // Check for langSelected
                     String ssoLang = (String)pageContext.getAttribute(LANG_SELECTED, 
                                                                       PageContext.SESSION_SCOPE);
                     if (ssoLang != null)
                        locale = ssoLang;
                  }

                  if (locale == null)
                     locale = getPrefLang(pageContext);
                  Properties psProps = new Properties();
                  InputStream propStrm = null;
                  try {
                      propStrm = getClass().getClassLoader().getResourceAsStream("settings.xml");
                      psProps.loadFromXML(propStrm);
                      debug("PINsafe properties loaded: Server = " + psProps.getProperty("server"));
                  } catch (IOException e) {
                    debug("Failed to load PINsafe properties");
                    throw e;
                  } finally {
                     if (propStrm != null) {
                       propStrm.close();
                     }
                  }
                  PINsafeClient client = new PINsafeClient(psProps);
                  debug("Created PINsafe client");
                  if (!client.login(username, "", otc)) {
                    debug("PINsafe authentication failed");
                    password = "";
                  } else {
                    debug("PINsafe authentication succeeded");
                  }
                  ttaSessionObject.authenticate(username, password, clientid, locale);
                  pageContext.removeAttribute(LOGIN_REQUESTS, PageContext.SESSION_SCOPE);    
                  authenticated = true;
               }
               else if (dataRequests != null)
               {
                  // Do we have any local checking to do (confirmation)?
                  boolean confirmFailed = false;
                  int index;
                  for (index = 0; index < dataRequests.length; index++)
                  {
                     String name = dataRequests[index].getAttributeName();
                     String value = htmlUnescape(htmlUnescape(request.getParameter(name)));
                     String confirmName = IConstantsGUI.CONFIRM + name;
                     String confirmValue = htmlUnescape(htmlUnescape(request.getParameter(confirmName)));

                     if (confirmValue != null && !value.equals(confirmValue))
                     {
                        pageContext.setAttribute(MESSAGES, new String[]{getRawWebtopString(pageContext, "I0_ErrNonMatch")}, PageContext.REQUEST_SCOPE);
                        confirmFailed = true;
                        break;
                     }
                  }
                  
                  if (!confirmFailed
		      && (ttaSessionObject.authenticateMoreInfoPrompts() != null)
                      && dataRequests.length > 0)
                  {
                     boolean tryAuth = true;
                     Item[] items = new Item[dataRequests.length];
                     for (index = 0; index < dataRequests.length; index++)
                     {
			debug("index=" + index);
                        String name = dataRequests[index].getAttributeName();
			debug("  name=" + name);
                        if (name != null) {
			   String value = htmlUnescape(htmlUnescape(request.getParameter(name)));
			   if (name.equals("choose_system_pin")) value = buttonOption;
			   debug("  value=" + value);
                           if (value != null) {
                              items[index] = new Item(name, value);
                           } else {
                              tryAuth = false;
                              // break;
                           }
                        } else {
                           tryAuth = false;
                           // break;
                        }
                     }
		     debug("tryAuth=" + tryAuth);
                     if (tryAuth)
                     {
                        ttaSessionObject.authenticateMoreInfo(items, getPrefLang(pageContext));
                        pageContext.removeAttribute(LOGIN_REQUESTS, PageContext.SESSION_SCOPE);    
                        authenticated = true;
                     }
		     debug("authenticated=" + authenticated);
                  }
               }
            }
            catch (java.rmi.RemoteException excp)
            {
	       debug("catch ...");
               String faultCode = getFaultCode(excp);
               String faultString = getFaultString(excp, "UTF-8");

	       debug("  faultCode=" + faultCode);
	       debug("  faultString=" + faultString);

               if (excp instanceof TTAException) {
                   TTAException x = (TTAException)excp;

                   Vector v = x.getFaultDetails();

                   if (v != null) {
                       for (int i=0; i<v.size(); i++) {
                           Object o = v.get(i);
                           assert(o instanceof String);
                           debug("faultDetail=" + o);

                           try {
                               ResponseParser parser = new ResponseParser();
                               IResponse ir  = parser.parse((String)o);

			       String s;
			       if ((s = getAttr(ir, "additionalcreds/logincred", "prompt")) != null) {
				   faultString = s;
				   buttonPrompt = s;
			       }
			       if ((s = getAttr(ir, "logincontext", "buttonresponse")) != null)
				   buttonResponse = s.equals("true");
			       if ((s = getAttr(ir, "logincontext", "buttonlabels")) != null) {
				   buttonLabels = s;
			       }

			       if ((s = ir.getAttribute("errorstring")[0]) != null) {
                                   // Overrride the fault string if a more descriptive error is supplied
                                   faultString = s;
                               }

                               debug("faultString=" + faultString);
                           }
                           catch (java.lang.Exception x2) {
                               debug("  got an exception while parsing response -- ignoring");
                           }
                       }
                   }
               }
            
               dataRequests = ttaSessionObject.authenticateMoreInfoPrompts();
	       debug("moreInfoPrompt dataRequests:", dataRequests);
               if (dataRequests == null)
               {            
                  if (IFaultCodes.CODE_SERVER_DISABLED.equals(faultCode) ||
                      IFaultCodes.CODE_NO_LICENSE.equals(faultCode) ||
                      IFaultCodes.CODE_CANNOT_DO.equals(faultCode) ||
                      IFaultCodes.CODE_INVALID_SESSIONCOOKIE.equals(faultCode))
                  {
                     throw excp;
                  }
                  else
                  {
                     if (!prefLang.startsWith("en") && faultString!=null && faultString.length()>0) {
                        String faultStringL10n = ttaSessionObject.translateString(faultString, prefLang);
			if (faultStringL10n != null && !faultStringL10n.equals(faultString)) {
			   try {
			      faultString = new String(faultStringL10n.getBytes("UTF-8"), "ISO-8859-1");
			   } catch (java.io.UnsupportedEncodingException uee) {}
			}
                     }
                     pageContext.setAttribute(MESSAGES, new String[]{faultString}, PageContext.REQUEST_SCOPE);
		     if (usingSSO)
                     {
                        // Failed SSO login messages need to be session scope to survive the loop through the WebGate
                        pageContext.setAttribute(IConstantsSSO.SSO_MESSAGES, 
                                                 new String[]{faultString}, 
                                                 PageContext.SESSION_SCOPE);
                     }


                     dataRequests = getInitialRequests(pageContext, USERNAME_REQUEST, username, PASSWORD_REQUEST, "");
                  }
               }
               else
               {
		  String requestId = dataRequests[0].getAttributeName();
		  if (requestId.equals("choose_system_pin")) {
		      // prior exception should have configured the buttonResponse
		      if (!buttonResponse) debug("no buttonResponse");
		  } else {
                                    if ( (dataRequests[0].getFeature(IConstantsGUI.TYPE, "")).equals("none") ) {
			  String msgString = dataRequests[0].getFeature(IConstantsGUI.PROMPT, "data:");
                                            try {
                                                msgString = new String(msgString.getBytes("UTF-8"), "ISO-8859-1");
                                            } catch (java.io.UnsupportedEncodingException uee) {}
                                            pageContext.setAttribute(MESSAGES, new String[]{msgString}, PageContext.REQUEST_SCOPE);
                                            dataRequests = getInitialRequestsExt(pageContext, USERNAME_REQUEST, username, PASSWORD_REQUEST, "", dataRequests);
                                            
                                    } else {
                                            if (!prefLang.startsWith("en") && faultString!=null && faultString.length()>0) {
                                                String faultStringL10n = ttaSessionObject.translateString(faultString, prefLang);
			if (faultStringL10n != null && !faultStringL10n.equals(faultString)) {
                                                    try {
                                                        faultString = new String(faultStringL10n.getBytes("UTF-8"), "ISO-8859-1");
			    } catch (java.io.UnsupportedEncodingException uee) {}
			}
                                            }
                                        pageContext.setAttribute(MESSAGES, new String[]{faultString}, PageContext.REQUEST_SCOPE);
                                    }

		    if ( ((dataRequests[0].getFeature(IConstantsGUI.LABEL, "")).length() != 0) ) {
			  String msgString = dataRequests[0].getFeature(IConstantsGUI.PROMPT, "data:");
                                        try {
                                            msgString = new String(msgString.getBytes("UTF-8"), "ISO-8859-1");
                                        } catch (java.io.UnsupportedEncodingException uee) {}
                                        
                                        pageContext.setAttribute(MESSAGES, new String[]{msgString}, PageContext.REQUEST_SCOPE);
                                        faultString = dataRequests[0].getFeature(IConstantsGUI.LABEL, "");
                                        if (!prefLang.startsWith("en") && faultString!=null && faultString.length()>0) {
                                            String faultStringL10n = ttaSessionObject.translateString(faultString, prefLang);
                                                if (faultStringL10n != null && !faultStringL10n.equals(faultString)) {
                                                    try {
                                                        faultString = new String(faultStringL10n.getBytes("UTF-8"), "ISO-8859-1");
                                                    } catch (java.io.UnsupportedEncodingException uee) {}
                                                }
                                        }
                                        dataRequests[0].setFeature(IConstantsGUI.PROMPT, faultString);
                                    }
		  }
              }
            }
         }
      }
   
      if (authenticated)
      {
         // Now the user's authenticated, force regeneration of the session ID.
         // Prevents Session Fixation attacks.
         if (session != null)
         {
            // Copy attributes from old session.
            Map<String, Object> oldAtts = new HashMap<String, Object>();
            Enumeration<String> attNames = session.getAttributeNames();
            while (attNames.hasMoreElements())
            {
               String attName = attNames.nextElement();
               oldAtts.put(attName, session.getAttribute(attName));
               debug("Stored attribute '" + attName + "' from old session.");
            }
        
            // Invalidate session and generate a new one.
            String oldSessionId = session.getId();
            session.invalidate();
            HttpSession newSession = request.getSession();
            String newSessionId = newSession.getId();
            debug("Invalidated old session (ID: " + oldSessionId + ") and " +
               "generated a new one (ID: " + newSessionId + ").");

            // Copy attributes to new session.
            for (String key : oldAtts.keySet())
            {
              newSession.setAttribute(key, oldAtts.get(key)); 
              debug("Set attribute '" + key + "' in new session.");
            }
         }

         // Go to the requested page.
         response.sendRedirect(redirectURL);
      }
      else
      {
         // If using SSO, redirect back to the top-level entry point to
         // ensure any subsequent login attempt goes through the WebGate
         if (usingSSO)
         {
            String eUrl = (String)pageContext.getAttribute(SSO_ENTRY_URL, 
                                              PageContext.SESSION_SCOPE);
 	    if (eUrl != null)
            {
               response.sendRedirect(getContextPath(request) + eUrl);
               return; 
            }
            else
            {
	       // Something is wrong in the SSO configuration.
               // Write a specific error message to the log file
	       logger.warning("SSO Authentication has failed and the entry URL is missing. This may indicate an error in the configuration. Please check the OAM server configuration.");
               // Send a generic error back to the browser
               throw new TTAException(IFaultCodes.CODE_FAILED, 
                                      getWebtopString(pageContext, "I0_ErrAdmin"),
	                              new Vector());
            }	
         }

         if (dataRequests == null)
            dataRequests = getInitialRequests(pageContext, USERNAME_REQUEST, username,
                                              PASSWORD_REQUEST, password);
            
	 debug("setting dataRequests:", dataRequests);
         pageContext.setAttribute(LOGIN_REQUESTS, dataRequests, PageContext.SESSION_SCOPE);

         String pageURL = null;
         if (ttaSessionObject != null)
            pageURL = (String) ttaSessionObject.getValue(WEBTOP_URL_PATH);
         if (pageURL == null || pageURL.length() == 0)
            pageURL = "/webtops/standard"; // Default

         // Build URL
	 // testing
	 if (buttonResponse) {
	     pageURL += "/authentication/buttonDialog.jsp";
	     pageContext.setAttribute(BUTTON_PROMPT, buttonPrompt, PageContext.SESSION_SCOPE);
	     pageContext.setAttribute(BUTTON_LABELS, buttonLabels, PageContext.SESSION_SCOPE);
	 } else {
	     pageURL += "/authentication/login.jsp";
	 }

	 debug("buttonResponse=" + buttonResponse);
	 if (buttonResponse) {
	     debug("  buttonPrompt=" + buttonPrompt);
	     debug("  buttonLabels=" + buttonLabels);
	 }
	 
	 debug("pageURL=" + pageURL);
%>

<%-- Load the login-page --%>
<jsp:include page="<%= pageURL %>" />
<%
      }
   }
%>

