<%@ page errorPage="/resources/jsp/errorpage.jsp" %>
<%@ page contentType="text/html" %>

<%@ page import="java.util.Enumeration" %>
<%@ page import="com.tarantella.tta.webservices.IAttributeNames" %>
<%@ page import="com.tarantella.tta.webservices.IConstants" %>
<%@ page import="com.tarantella.tta.webservices.IConstantsGUI" %>
<%@ page import="com.tarantella.tta.webservices.IConstantsXML" %>
<%@ page import="com.tarantella.tta.webservices.client.views.DataRequest" %>
<%@ page import="com.tarantella.tta.webservices.client.views.SessionBean" %>
<%@ page import="org.owasp.esapi.ESAPI" %>

<%-- Webtop Session Management --%>
<%@ include file="/resources/jsp/utilities.jsp" %>
<%@ include file="/resources/jsp/localeutils.jsp" %>
<%
   pageContext.setAttribute(PARAM_SESSION_AUTHENTICATE, "false", PageContext.REQUEST_SCOPE);

   /* If you want a language selection menu on the login dialog */
   /* set a string value or if not set to null                  */
   String menuOn = "on"; /* or null */

   // If the request contains a valid selected lang, save it for the session
   if (request.getParameter(LANG_SELECTED) != null)
   {
      String langSelected = 
         validateSelectedLang(request.getParameter(LANG_SELECTED), null);
      if (langSelected != null)
      {
         pageContext.setAttribute(LANG_SELECTED, langSelected, 
            PageContext.SESSION_SCOPE);
      }
   }
%>

<%
   // initialise class variables
   setContext(request, response, pageContext);
   setLoginGifPath(pageContext, getContextPath(request) + "/resources/images/login/");
%>

<!DOCTYPE html>
<html lang="<%=getHtmlLang(pageContext)%>">
<head>
<title><%=getWebtopString(pageContext, "I0_SSGDSoftware")%></title>
<meta http-equiv="Content-Type" content="text/html; charset=<%=getHtmlCharSet()%>">
<meta http-equiv="X-UA-Compatible" content="requiresActiveX=true, IE=Edge" />
<link rel="stylesheet" type="text/css" href="<%= getDialogStyleSheet(request, pageContext) %>" />
<link rel="stylesheet" type="text/css" href="<%= getButtonStyleSheet(pageContext) %>">
<link rel="stylesheet" type="text/css" href="<%= getStyleSheet(request, pageContext) %>">

<meta name="apple-mobile-web-app-title" content="Oracle SGD">
<link rel="apple-touch-icon-precomposed" href="<%=getContextPath(request)%>/h5c/img/icon.png" />
<link rel="apple-touch-icon-precomposed" sizes="72x72" href="<%=getContextPath(request)%>/h5c/img/icon.png" />
<link rel="apple-touch-icon-precomposed" sizes="114x114" href="<%=getContextPath(request)%>/h5c/img/icon@2x.png" />
<link rel="apple-touch-icon-precomposed" sizes="144x144" href="<%=getContextPath(request)%>/h5c/img/icon144.png" />

<%
   response.setHeader("Cache-Control","no-cache"); //HTTP 1.1^M
   response.setHeader("Pragma","no-cache"); //HTTP 1.0^M
   response.setDateHeader ("Expires", 0); //prevents caching at the proxy server^M

   String host = null;
   String noSession = request.getParameter("nosession");
   if (noSession != null && noSession.equalsIgnoreCase("true"))
   {
      host = "";
   }
   else
   {
      SessionBean ttaSessionObject = getSGDSession(pageContext, SESSION_OBJ);
      if (ttaSessionObject != null)
         host = (String) ttaSessionObject.getAttribute(IConstantsXML.NAME_CONNECTION_ATTRS, IAttributeNames.HOST);
 
      if (host == null)
         host = "";
   }

    String[] ttaMessages = (String[])pageContext.getAttribute(MESSAGES, PageContext.REQUEST_SCOPE);

   String destination = request.getParameter("destination");
   String loginAttemptURL = null;
   if (destination != null)
   {
      loginAttemptURL = destination;
      menuOn = null;
   }
   else
   {
      loginAttemptURL = getContextPath(request) + "/authentication/ttaAuthentication.jsp";
   }

   DataRequest[] dataReqs = (DataRequest[])pageContext.getAttribute(LOGIN_REQUESTS, PageContext.SESSION_SCOPE);

   String menushow = "hide";
%>


<script type="text/javascript">
function checkEnter() 
{
    if(window.event) {
      if (window.event.keyCode == 13) {
        document.getElementById('login').click();
      }
    }
}

function getIEVersion()
{
     var version = -1; 
     if (navigator.appName != 'Microsoft Internet Explorer') 
        return version;

     var agent = navigator.userAgent;
     var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
     if (re.exec(agent) != null)
        version = parseFloat(RegExp.$1);
          
     return version;
}


/* This function adds event handlers to controls in IE8
   so that submit on enter works
   see CR:6969452 

   IE detection based on : Giorgio Sardo's blog entry at 
   http://blogs.msdn.com/b/giorgio/archive/2009/04/14/how-to-detect-ie8-using-javascript-client-side.aspx
 */  
function fixIE8()
{
     var version = getIEVersion();
     if (version == -1 || version > 8.0)
        return;
<%
      for (int i=0; i<dataReqs.length; i++) {
%>
         var el = document.getElementById("<%=dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" );
         el.attachEvent("onkeydown", checkEnter); 

<%  
         if(dataReqs[i].getFeature(IConstantsGUI.CONFIRM, false)) {
%>
         var elConfirm = document.getElementById("<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>" );
         elConfirm.attachEvent("onkeydown", checkEnter); 
<%
         }
      }
%>

}

function showTuring() {
  var turingDiv = document.getElementById("divTuring");
  var username = document.getElementById("Username").value;
  if (username == "") {
    turingDiv.style.display = "none";
  } else {
    turingDiv.style.display = "";
    var turingImg = document.getElementById("imgTuring");
    turingImg.style.display = "";
    turingImg.src = "/sgd/turing.jsp?username=" + username + "&random=" + Math.floor(Math.random() * 10000);
  }
}

function showOtc() {
  // Insert OTC field and label in a row above the login button
  // Make sure it's not already there.
  var loginBtn = document.getElementById('login');
  if (loginBtn) {
    var sibling = loginBtn.parentNode;
    var container = sibling.parentNode;
    while (sibling.className != 'dialogBody') {
      sibling = container;
      container = container.parentNode;
    }
    sibling = sibling.nextSibling;
    var otcRow = document.getElementById('trOtc');
    var turingDiv = document.getElementById("divTuring");
    var username = document.getElementById("Username");
    if (!turingDiv) {
      turingDiv = document.createElement("div");
      turingDiv.id = 'divTuring';
      var turImg = document.createElement("img");
      turImg.id = "imgTuring";
      turingDiv.appendChild(turImg);
      var turBtn = document.createElement("input");
      turBtn.type = "button";
      turBtn.className = "button-grey";
      turBtn.value = "Refresh Image";
      turBtn.onclick = showTuring;
      turingDiv.appendChild(document.createElement("br"));
      turingDiv.appendChild(turBtn);
      container.insertBefore(turingDiv, sibling);
      if (username.value == "") {
        turingDiv.style.display = "none";
      } else {
        turingDiv.style.display = "";
        showTuring();
      }
      username.onblur = showTuring;
    }
  }
}

function showPage() {
   if ( self == top ) {
     document.getElementById('errorpage').style.display='none';
     document.getElementById('realpage').style.visibility='visible';
   } else {
     top.location=self.location;
   }
  showOtc();
}

</SCRIPT>

<style>
ul
{
  padding: 0;
  margin: 0;
  list-style: none;
}

li
{
  background-color: #ffffff;
  list-style: none;
  float: left;
  position: relative;
  width: 10em;
  color: red;
}

a:link
{
}

li ul
{
  display: none;
  padding: 0;
  margin: 0;
}

li:link ul
{
  color: red;
}

li:hover ul
{
  display: block;
}

.menudisplay
{
  top: 10px;
  left: -200px;
  position: relative;
  z-index: 1;
  visibility: show;
}

.menudisplay a
{
  color: black;
}

</style>

</head>


<%
if (dataReqs == null)
{
%>
<body class="dialogPageBackground" onload="showPage();">
<div id="errorpage">
  <%@ include file="/resources/jsp/erroraccessprevented.jsp" %>
</div>

<div id="realpage" style="visibility:hidden;">
  <%@ include file="/resources/jsp/errornodatareqs.jsp" %>
   <STRONG><%=getWebtopString(pageContext, "I0_ErrNoDataRequests")%></STRONG>
</div>
<%
}
else
{
    int nfocus = 0;
    if ( dataReqs.length>0 ) {
        if ( dataReqs[0].getFeature(IConstantsGUI.VALUE, "").length() > 0 )
            nfocus=1;
    }

%>


<body class="dialogPageBackground" onLoad="showPage(); document.auth.<%= dataReqs[nfocus].getAttributeName() %>.focus();">
<div id="errorpage">
  <%@ include file="/resources/jsp/erroraccessprevented.jsp" %>
</div>

<div id="realpage" style="visibility:hidden;">

<div align="center">
   <div class="dialogTop">
      <div id="dialogHeaderWrapper">
         <h1 id="dialogHeader" > <%=getWebtopString(pageContext, "I0_SSGDSoftwareShort")%> </h1>
      </div>
   </div>

   <div class="dialogBody">
      <div class="dialogContent">
         <table class="dsR2" border="0" cellspacing="8" cellpadding="0" role="presentation">
         <form name="auth" action="<%= ESAPI.encoder().encodeForHTMLAttribute(response.encodeURL(loginAttemptURL)) %>" method=POST autocomplete="<%= getAutoCompleteAttribute() %>">
<%
         for (int i=0; i<dataReqs.length; i++) {
           if (dataReqs[i].getAttributeName().equals("Username"))
             menushow = "show";
%>
         <tr>
             <% if(dataReqs[i].getFeature(IConstantsGUI.TYPE, "text").equalsIgnoreCase("hidden")) { %>
                <td><label  style="visibility: collapse;" for="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>"><%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %></label></td>
             <% } else { %>
                <td><label for="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>"><%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %></label></td>
            <% } %>
            <td>
            <input id="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" 
                   alt="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "data:") %>" 
                   name="<%= dataReqs[i].getAttributeName() %>" 
                   type="<%= dataReqs[i].getFeature(IConstantsGUI.TYPE, "text") %>" 
                   size="<%= dataReqs[i].getFeature(IConstantsGUI.SIZE, 15) %>" 
                   maxlength="<%= dataReqs[i].getFeature(IConstantsGUI.MAXLENGTH, 100) %>" 
                   value="<%= htmlEscape(dataReqs[i].getFeature(IConstantsGUI.VALUE, "")) %>" 
                   autocapitalize="off"
                   autocorrect="off"
                   autocomplete="off"
                   spellcheck="false"
                   style="width:150px">
            </td>
         </tr>
<%
         // Do we need to confirm?
         if(dataReqs[i].getFeature(IConstantsGUI.CONFIRM, false)) {
%>
         <tr>
            <td><label for="<%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "") %>">
                       <%=getWebtopString(pageContext, "I0_LoginConfirm")%> 
                       <%= dataReqs[i].getFeature(IConstantsGUI.PROMPT, "") %>
                </label>
             </td>
             <td>
             <input id="<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>"
                    name="<%= IConstantsGUI.CONFIRM + dataReqs[i].getAttributeName() %>" 
                    type="<%= dataReqs[i].getFeature(IConstantsGUI.TYPE, "text") %>" 
                    size="<%= dataReqs[i].getFeature(IConstantsGUI.SIZE, 15) %>" 
                    maxlength="<%= dataReqs[i].getFeature(IConstantsGUI.MAXLENGTH, 100) %>" 
                    value="<%= htmlEscape(dataReqs[i].getFeature(IConstantsGUI.VALUE, "")) %>" 
                    style="width:150px"
                    autocomplete="off">
             </td>
         </tr>
<%
         }
         } //end of the for loop
%>

         <tr>
            <td></td>
            <td>
               <input id="login" alt="<%=getWebtopString(pageContext, "I0_Login")%>" 
                                 type="submit" name="login" class="button-grey"
                                 value="<%=getWebtopString(pageContext, "I0_Login")%>" >
            </td>
         </tr>
         </form>
         </table>
<%
         if (ttaMessages != null) {
            for (int i=0; i<ttaMessages.length; i++) {
%>
               <p class="boldGray"><%= getStringByCharSet(ttaMessages[i]) %></p>
<%
            }
         } 
%>
      </div>
   </div>
   <div class="dialogBottom">
<%
    if ( (menuOn != null) &&menushow.equals("show") )
    {
      String selectedlang = getHtmlLang(pageContext);
      String langdesc = "";
      String langurl  = "";
      if (selectedlang.equals("en")) langdesc="English";
      if (selectedlang.equals("de")) langdesc="Deutsch";
      if (selectedlang.equals("es")) langdesc="Espa&ntilde;ol";
      if (selectedlang.equals("fr")) langdesc="Fran&ccedil;ais";
      if (selectedlang.equals("it")) langdesc="Italiano";
      if (selectedlang.equals("pt_BR")) langdesc="Portugu&ecirc;s";
      if (selectedlang.equals("ja")) langdesc="&#x65E5;&#x672C;&#x8A9E;";
      if (selectedlang.equals("ko")) langdesc="&#xD55C;&#xAD6D;&#xC5B4;";
      if (selectedlang.equals("zh_CN")) langdesc="&#x4E2D;&#x6587;&#x7B80;&#x4F53;&#x5B57;";
      if (selectedlang.equals("zh_TW")) langdesc="&#x4E2D;&#x6587;&#x7E41;&#x9AD4;&#x5B57;";

      langurl = getContextPath(request)+"/index.jsp?langSelected="+ selectedlang;
%>
    <div class="menudisplay">
      <table border="0" cellspacing="8" cellpadding="0">
        <tr>
          <td>
            <ul style="width:60px; padding-top:37px">
              <li class="selected"> <a href="<%= response.encodeURL(langurl)%>" target="_top"><%= langdesc %></a>
                <img src="<%=getContextPath(request)%>/resources/images/login/tmp_arrow.png" alt="arrow" height="9px" width="9px" style="padding-left: 2px;" />
            <ul>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=en")%>" target="_top">English</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=de")%>" target="_top">Deutsch</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=es")%>" target="_top">Espa&ntilde;ol</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=fr")%>" target="_top">Fran&ccedil;ais</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=it")%>" target="_top">Italiano</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=pt-br")%>" target="_top">Portugu&ecirc;s</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=ja")%>" target="_top">&#x65E5;&#x672C;&#x8A9E;</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=ko")%>" target="_top">&#xD55C;&#xAD6D;&#xC5B4;</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=zh-cn")%>" target="_top">&#x4E2D;&#x6587;&#x7B80;&#x4F53;&#x5B57;</a></li>
               <li> <a href="<%= response.encodeURL(getContextPath(request)+"/index.jsp?langSelected=zh-tw")%>" target="_top">&#x4E2D;&#x6587;&#x7E41;&#x9AD4;&#x5B57;</a></li>
            </ul>
         </li>
      </ul>
          </td>
        </tr>
      </table>
    </div>
<%
   }
%>
   </div>
</div>
</div>
<%
 }
%>
</body>
</html>
